#include <iostream>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "arraystack.h"
#include "linkstack.h"

using namespace std;

int matches(char prevchar, char nextchar){
	if ( (prevchar == '(') && (nextchar == ')'))
		return TRUE;
	if ( (prevchar == '[') && (nextchar == ']'))
		return TRUE;
	return FALSE;
}



int main(int argc, char *argv[]){
	char line[30];
	int i,len;
	char c,topchar;

	/* create an empty stack */
	if (argc < 2) {
		cout << "Insufficient inputs" << endl;
		exit(1);
	}


	Stack *stack;
	if (atoi(argv[1]) == 1){
		cout << "Using an array based stack " << endl;
		stack = new ArrayStack();
	}
	else {
		cout << "Using a linked list based stack " << endl;
		stack = new LinkStack();
	}

	/* read the paranthesis string from standard input */
	cin >> line ;

	/* iterate through every character in line */
	len = strlen(line);
	for(i=0; i < len; i++){
		/* read the character */
		c = line[i];

		if (isspace(c))
			continue;
		else if ( (c == '(') || (c == '['))
			stack->push(c);
		else { 
			/* closing bracket  ) ] */
			topchar = stack->peek();
			if (matches(topchar, c)){
				stack->pop();
			} else {
				cout << "Parantheses not balanced " << endl;
				return 1;
			}
		}
	}

	/* reached the end */
	if (stack->isEmpty())
		cout << "Parantheses are balanced " << endl;
	else
		cout << "Parantheses not balanced " << endl;

	return 0;
}












